---
title: Create and update customers
slug: data-platform/api/create-and-update-customers
docTags: 
createdAt: 2026-09-02T14:41:00.110Z
---

{
  "id": "SlR2P-xA1GKF8eFBKHMcF",
  "type": "api-oas-v2",
  "data": {
    "method": "POST",
    "url": "https://api.us1.odp.optimizely.com/v3/profiles",
    "servers": [
      {
        "url": "https://api.us1.odp.optimizely.com/v3/profiles",
        "description": "United States"
      },
      {
        "url": "https://api.eu1.odp.optimizely.com/v3/profiles",
        "description": "Europe"
      },
      {
        "url": "https://api.au1.odp.optimizely.com/v3/profiles",
        "description": "Asia-Pacific"
      }
    ],
    "name": "Create and update customers",
    "description": "Update the attributes and identifiers of a customer.",
    "contentType": "application/json",
    "request": {
      "pathParameters": [],
      "headerParameters": [
        {
          "name": "accept",
          "type": "string",
          "kind": "optional",
          "description": "Generated from available response content types",
          "enum": [
            "application/json"
          ],
          "default": "application/json"
        }
      ],
      "queryParameters": [],
      "bodyDataParameters": [
        {
          "kind": "required",
          "name": "body",
          "type": "array",
          "example": "[{\"attributes\":{\"first_name\":\"Johnny\",\"last_name\":\"Test\",\"email\":\"sample@test.com\",\"phone\":\"555-867-5309\",\"street1\":\"123 Fake St\",\"street2\":\"Apt 101\",\"city\":\"Boston\",\"state\":\"MA\",\"zip\":\"02101\",\"country\":\"USA\",\"timezone\":\"America/New_York\",\"gender\":\"M\"}},{\"attributes\":{\"first_name\":\"Jenny\",\"last_name\":\"Example\",\"email\":\"example@notreal.com\",\"phone\":\"555-555-5555\",\"street1\":\"456 Imaginary Ln\",\"city\":\"Leesburg\",\"state\":\"Virginia\",\"zip\":\"20175\",\"country\":\"United States\",\"timezone\":\"America/New_York\",\"gender\":\"F\"}}]",
          "examples": [
            {
              "label": "Example Payload",
              "value": "[{\"attributes\":{\"first_name\":\"Johnny\",\"last_name\":\"Test\",\"email\":\"sample@test.com\",\"phone\":\"555-867-5309\",\"street1\":\"123 Fake St\",\"street2\":\"Apt 101\",\"city\":\"Boston\",\"state\":\"MA\",\"zip\":\"02101\",\"country\":\"USA\",\"timezone\":\"America/New_York\",\"gender\":\"M\"}},{\"attributes\":{\"first_name\":\"Jenny\",\"last_name\":\"Example\",\"email\":\"example@notreal.com\",\"phone\":\"555-555-5555\",\"street1\":\"456 Imaginary Ln\",\"city\":\"Leesburg\",\"state\":\"Virginia\",\"zip\":\"20175\",\"country\":\"United States\",\"timezone\":\"America/New_York\",\"gender\":\"F\"}}]"
            }
          ],
          "description": "",
          "customType": "ProfileUpdateRequest[]",
          "schema": [
            {
              "name": "attributes",
              "kind": "optional",
              "type": "map",
              "description": "",
              "example": "",
              "customType": "map<string, string>",
              "schema": []
            }
          ],
          "modelRef": "#/components/schemas/ProfileUpdateRequest",
          "isExpanded": true
        }
      ],
      "formDataParameters": [],
      "oAuthParameters": [
        {
          "id": "x-api-key",
          "name": "x-api-key",
          "kind": "optional",
          "type": "apiKey",
          "in": "header"
        }
      ],
      "cookieParameters": []
    },
    "responses": [
      {
        "statusCode": "202",
        "description": "Accepted",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "",
            "customType": "GenericUpdateResponse",
            "schema": [
              {
                "name": "title",
                "kind": "optional",
                "type": "string",
                "description": ""
              },
              {
                "name": "status",
                "kind": "optional",
                "type": "integer<int32>",
                "description": "",
                "format": "int32"
              },
              {
                "name": "timestamp",
                "kind": "optional",
                "type": "string",
                "description": ""
              }
            ],
            "modelRef": "#/components/schemas/GenericUpdateResponse",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "400",
        "description": "Bad Request",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "undefined",
            "example": "{\"title\":\"Bad Request\",\"status\":400,\"timestamp\":\"2018-09-10T21:07:10-05:00\",\"detail\":{\"invalids\":[{\"field\":\"delimiter\",\"reason\":\"Unrecognized delimiter, valid options are comma, tab or pipe\"}]}}",
            "description": "",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "403",
        "description": "Forbidden",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "undefined",
            "example": "{  \"message\": \"Forbidden\"}",
            "description": "",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "404",
        "description": "Not Found",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "undefined",
            "example": "{\"title\":\"Bad Request\",\"status\":404,\"timestamp\":\"2018-09-10T21:07:10-05:00\",\"detail\":{\"message\":\"Not found description\"}}",
            "description": "",
            "isExpanded": true
          }
        ]
      }
    ],
    "hasXCodeSamples": false,
    "examples": {
      "languages": [
        {
          "id": "ywCERqj0jyMdVe4k_uTt7",
          "language": "curl",
          "label": "cURL",
          "code": "curl --request POST \\\n     --url https://api.us1.odp.optimizely.com/v3/profiles \\\n     --header 'accept: application/json' \\\n     --header 'content-type: application/json' \\\n     --data '[\n     {}\n     ]'"
        },
        {
          "id": "k2O47FiYGFBrT-hoIl2W6",
          "language": "javascript",
          "label": "javascript",
          "code": "var myHeaders = new Headers();\nmyHeaders.append(\"accept\", \"application/json\");\nmyHeaders.append(\"content-type\", \"application/json\");\n\nvar raw = JSON.stringify([\n   {}\n]);\n\nvar requestOptions = {\n   method: 'POST',\n   headers: myHeaders,\n   body: raw,\n   redirect: 'follow'\n};\n\nfetch(\"https://api.us1.odp.optimizely.com/v3/profiles\", requestOptions)\n   .then(response => response.text())\n   .then(result => console.log(result))\n   .catch(error => console.log('error', error));"
        },
        {
          "id": "uZEN0VNUjY_QBCziyIt1M",
          "language": "ruby",
          "label": "Ruby",
          "code": "require \"uri\"\nrequire \"json\"\nrequire \"net/http\"\n\nurl = URI(\"https://api.us1.odp.optimizely.com/v3/profiles\")\n\nhttps = Net::HTTP.new(url.host, url.port)\nhttps.use_ssl = true\n\nrequest = Net::HTTP::Post.new(url)\nrequest[\"accept\"] = \"application/json\"\nrequest[\"content-type\"] = \"application/json\"\nrequest.body = JSON.dump([\n   {}\n])\n\nresponse = https.request(request)\nputs response.read_body\n"
        },
        {
          "id": "pBWKRaoeipluBHMCfEIo_",
          "language": "python",
          "label": "Python",
          "code": "import requests\nimport json\n\nurl = \"https://api.us1.odp.optimizely.com/v3/profiles\"\n\npayload = json.dumps([\n   {}\n])\nheaders = {\n   'accept': 'application/json',\n   'content-type': 'application/json'\n}\n\nresponse = requests.request(\"POST\", url, headers=headers, data=payload)\n\nprint(response.text)\n"
        }
      ],
      "selectedLanguageId": "ywCERqj0jyMdVe4k_uTt7"
    },
    "results": {
      "languages": [
        {
          "id": "response-0-202",
          "language": "202",
          "code": "// Accepted\n{\n  \"title\": \"\",\n  \"status\": \"\",\n  \"timestamp\": \"\"\n}"
        },
        {
          "id": "response-1-400",
          "language": "400",
          "code": "// Bad Request\n\"{\\\"title\\\":\\\"Bad Request\\\",\\\"status\\\":400,\\\"timestamp\\\":\\\"2018-09-10T21:07:10-05:00\\\",\\\"detail\\\":{\\\"invalids\\\":[{\\\"field\\\":\\\"delimiter\\\",\\\"reason\\\":\\\"Unrecognized delimiter, valid options are comma, tab or pipe\\\"}]}}\""
        },
        {
          "id": "response-2-403",
          "language": "403",
          "code": "// Forbidden\n\"{  \\\"message\\\": \\\"Forbidden\\\"}\""
        },
        {
          "id": "response-3-404",
          "language": "404",
          "code": "// Not Found\n\"{\\\"title\\\":\\\"Bad Request\\\",\\\"status\\\":404,\\\"timestamp\\\":\\\"2018-09-10T21:07:10-05:00\\\",\\\"detail\\\":{\\\"message\\\":\\\"Not found description\\\"}}\""
        }
      ],
      "selectedLanguageId": "response-0-202"
    }
  },
  "children": [
    {
      "text": ""
    }
  ]
}